﻿workflow paralleltest {

    param(
        [Object[]]$ServicesList,
        [System.ServiceProcess.ServiceController]$FirstService
    ) 

    InlineScript { Write-Host "output single FirstService object:"}
    $FirstService.DisplayName

    InlineScript {Write-Host "output all services async:"}
    foreach -parallel ($service in [System.ServiceProcess.ServiceController[]]$ServicesList) {
        $service
    }

}

#get 10 local windows services
$input = Get-Service | Select-Object -first 10;

#get type of $input list
$input.GetType().FullName

#get type of $input item 
$input[0].GetType().FullName

#test workflow with arguments of complex types
paralleltest -ServicesList $input -FirstService $input[0]